Ext.namespace('Zarafa.plugins.sin_jitsi');
Zarafa.plugins.sin_jitsi.SettingsCategory = Ext.extend(Zarafa.settings.ui.SettingsCategory, {

  constructor: function(config){
    config = config || {};
    Ext.applyIf(config, {
      title: 'Jitsi Webmeetings',
      categoryIndex: 9947,
      xtype: 'siedl.jitsi.settingscategory',
      iconCls: 'icon_sin_jitsi',
      items: [{
        xtype: 'siedl.jitsi.settingswidget',
        settingsContext: config.settingsContext
      }]
    });
    Zarafa.plugins.sin_jitsi.SettingsCategory.superclass.constructor.call(this, config);
  }

});
Ext.reg('siedl.jitsi.settingscategory', Zarafa.plugins.sin_jitsi.SettingsCategory);

Zarafa.plugins.sin_jitsi.SettingsWidget = Ext.extend(Zarafa.settings.ui.SettingsWidget, {

  constructor: function(config){
    config = config || {};
    Ext.applyIf(config, {
      xtype: 'siedl.jitsi.settingswidget',
      title: 'Jitsi Webmeetings',
      layout: 'form',
      items: [
        {
          xtype: 'displayfield',
          hideLabel: true,
          value: _('Open webmeetings in:', 'plugin_sin_jitsi')
        },{
          xtype: 'radiogroup',
          ref: 'openInRadio',
          hideLabel: true,
          columns: 1,
          items: [
            {
              xtype: 'radio',
              name: 'openin',
              inputValue: 'webapp',
              boxLabel: _('WebApp tab')
            },{
              xtype: 'radio',
              name: 'openin',
              inputValue: 'popup',
              boxLabel: 'Popup'
            },{
              xtype: 'radio',
              name: 'openin',
              inputValue: 'browser',
              boxLabel: _('Browser window') + '<span class="k-settings-label-minor">(' + _('This will open webmeetings in an external browser if using DeskApp', 'plugin_sin_jitsi') + ')</span>'
            }
          ]
        },{
          xtype: 'checkbox',
          ref: 'hideTabbarButtonCheckbox',
          boxLabel: _('Hide the button in the main toolbar', 'plugin_sin_jitsi'),
          checked: false,
          hideLabel : true,
          style: 'margin-top: 5px',
        },{
          xtype: 'checkbox',
          ref: 'mnameAddSubject',
          boxLabel: _('Add the subject to the room name', 'plugin_sin_jitsi'),
          checked: true,
          hideLabel : true,
          style: 'margin-top: 5px',
        },{
          xtype: 'checkbox',
          ref: 'mnameAddOrganizer',
          boxLabel: _('Add the organizer name to the room name', 'plugin_sin_jitsi'),
          checked: true,
          hideLabel : true,
          style: 'margin-top: 5px',
        },{
          xtype: 'checkbox',
          ref: 'locationAddCheckbox',
          boxLabel: _('Add the URL to the meeting location rather than overwriting it', 'plugin_sin_jitsi'),
          checked: true,
          hideLabel : true,
          style: 'margin-top: 5px',
        },{
          xtype: 'checkbox',
          ref: 'locationFixCheckbox',
          boxLabel: _('Prevent the URL in the meeting location from being ﻿overridden automatically (ex: when adding a meetingroom)', 'plugin_sin_jitsi') + '<span class="k-settings-label-minor">(' + _('If you have problems when creating meetings, try disabling this setting', 'plugin_sin_jitsi') + ')</span>',
          checked: true,
          hideLabel : true,
          style: 'margin-top: 5px',
        },{
          xtype: 'checkbox',
          ref: 'addInvitationCheckbox',
          boxLabel: _('Add an invitation to the appointment description', 'plugin_sin_jitsi'),
          checked: true,
          hideLabel : true,
          style: 'margin-top: 5px',
        },{
          xtype: 'displayfield',
          hideLabel: true,
          style: 'margin-top: 5px',
          value: _('Invitation text', 'plugin_sin_jitsi') + ': <span class="k-settings-label-minor">(' + _('must contain %url% as a placeholder for the meeting link, empty the textbox to reset to default', 'plugin_sin_jitsi') + ')</span>',
        },{
          xtype: 'textarea',
          ref: 'invitationEditor',
          hideLabel: true,
          grow: true,
          anchor: '100%',
        }
      ]
    });
    Zarafa.plugins.sin_jitsi.SettingsWidget.superclass.constructor.call(this, config);
  },

  update: function(settingsModel){
    this.openInRadio.setValue(settingsModel.get('zarafa/v1/plugins/sin_jitsi/openin') || 'webapp');
    this.hideTabbarButtonCheckbox.setValue(settingsModel.get('zarafa/v1/plugins/sin_jitsi/hidetabbarbutton'));
    this.locationAddCheckbox.setValue(!settingsModel.get('zarafa/v1/plugins/sin_jitsi/locationoverride'));
    this.locationFixCheckbox.setValue(!settingsModel.get('zarafa/v1/plugins/sin_jitsi/nolocationfix'));
    this.addInvitationCheckbox.setValue(!settingsModel.get('zarafa/v1/plugins/sin_jitsi/noinvitation'));
    this.invitationEditor.setValue(settingsModel.get('zarafa/v1/plugins/sin_jitsi/invitationmessage') || '');
    this.mnameAddSubject.setValue(!container.getSettingsModel().get('zarafa/v1/plugins/sin_jitsi/mname_nosubject'));
    this.mnameAddOrganizer.setValue(!container.getSettingsModel().get('zarafa/v1/plugins/sin_jitsi/mname_noorganizer'));
  },

  updateSettings: function(settingsModel){
    settingsModel.beginEdit();
    if(settingsModel.get('zarafa/v1/plugins/sin_jitsi/hidetabbarbutton') != this.hideTabbarButtonCheckbox.checked || settingsModel.get('zarafa/v1/plugins/sin_jitsi/nolocationfix') == this.locationFixCheckbox.checked){
      settingsModel.requiresReload = true;
    }
    settingsModel.set('zarafa/v1/plugins/sin_jitsi/openin', this.openInRadio.getValue().inputValue);
    settingsModel.set('zarafa/v1/plugins/sin_jitsi/hidetabbarbutton', this.hideTabbarButtonCheckbox.checked);
    settingsModel.set('zarafa/v1/plugins/sin_jitsi/locationoverride', !this.locationAddCheckbox.checked);
    settingsModel.set('zarafa/v1/plugins/sin_jitsi/nolocationfix', !this.locationFixCheckbox.checked);
    settingsModel.set('zarafa/v1/plugins/sin_jitsi/noinvitation', !this.addInvitationCheckbox.checked);
    settingsModel.set('zarafa/v1/plugins/sin_jitsi/mname_nosubject', !this.mnameAddSubject.checked);
    settingsModel.set('zarafa/v1/plugins/sin_jitsi/mname_noorganizer', !this.mnameAddOrganizer.checked);
    if(this.invitationEditor.getValue()){
      if(this.invitationEditor.getValue() != settingsModel.get('zarafa/v1/plugins/sin_jitsi/invitationmessage')){
        settingsModel.set('zarafa/v1/plugins/sin_jitsi/invitationmessage', this.invitationEditor.getValue())
      }
    }else{
      settingsModel.remove('zarafa/v1/plugins/sin_jitsi/invitationmessage');
      settingsModel.requiresReload = true;
    }
    settingsModel.endEdit();
  },

});
Ext.reg('siedl.jitsi.settingswidget', Zarafa.plugins.sin_jitsi.SettingsWidget);