<?php
class Pluginsin_jitsi extends Plugin{

  function init(){
    $this->registerHook('server.core.settings.init.before');
  }

  /**
   * Function is executed when a hook is triggered by the PluginManager
   *
   * @param string $eventID the id of the triggered hook
   * @param mixed $data object(s) related to the hook
   */
  function execute($eventID, &$data){
    if($eventID == 'server.core.settings.init.before'){
      $this->injectPluginSettings($data);
    }
  }


  /**
   * Called when the core Settings class is initialized and ready to accept sysadmin default
   * settings.
   * @param Array $data Reference to the data of the triggered hook
   */
  function injectPluginSettings(&$data){
    if(defined('SIN_JITSI_DEFAULTS') && is_array(SIN_JITSI_DEFAULTS)){
      $data['settingsObj']->addSysAdminDefaults(
        Array(
          'zarafa' => Array(
            'v1' => Array(
              'plugins' => Array(
                'sin_jitsi' => SIN_JITSI_DEFAULTS
              )
            )
          )
        )
      );
    }
  }
}
?>